package org.jeecg.modules.flowable.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import jakarta.servlet.http.HttpServletRequest;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.flowable.apithird.business.entity.SysListener;
import org.jeecg.modules.flowable.apithird.business.service.ISysListenerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;

@RestController
@RequestMapping("/flowable/listener")
@Slf4j
public class SysListenerController extends JeecgController<SysListener, ISysListenerService> {
	@Autowired
	private ISysListenerService sysListenerService;

	@GetMapping(value = "/list")
	public Result<IPage<SysListener>> queryPageList(SysListener sysListener,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<SysListener> queryWrapper = QueryGenerator.initQueryWrapper(sysListener, req.getParameterMap());
		Page<SysListener> page = new Page<SysListener>(pageNo, pageSize);
		IPage<SysListener> pageList = sysListenerService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	@AutoLog(value = "sys_listener-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody SysListener sysListener) {
		sysListenerService.save(sysListener);
		return Result.OK("添加成功！");
	}

	@AutoLog(value = "sys_listener-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody SysListener sysListener) {
		sysListenerService.updateById(sysListener);
		return Result.OK("编辑成功!");
	}

	@AutoLog(value = "sys_listener-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) Integer id) {
		sysListenerService.removeById(id);
		return Result.OK("删除成功!");
	}

	@AutoLog(value = "sys_listener-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.sysListenerService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	@GetMapping(value = "/queryById")
	public Result<SysListener> queryById(@RequestParam(name="id",required=true) String id) {
		SysListener sysListener = sysListenerService.getById(id);
		if(sysListener==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(sysListener);
	}


}
